#ifndef _PHWALL_H_
#define _PHWALL_H_

#include "RBcollisions.h"

// maximalny pocet tehal, z ktorych je zlozeny mur
#define MAX_BRICKS 10

// CPhBrick - trieda pre pracu s tehlou a jej fyzikou **********************
class CPhBrick:public CCollisionBox
{
 // tu vkladat iba funkcie nie premenne!
 // funkcii detect_and_resolve_collisions() sa odovzdava adresa pamatoveho
 // bloku, v ktorom su ulozene objekty rodicovskej triedy CCollisionBox
 public:
  // vykreslenie vsetkych trojuholnikov, z ktorych je zlozene RB
  void draw(void) {
   rb->get_GLtransform(mat);

   glPushMatrix();
   glMultMatrixf(mat);

   glBegin(GL_TRIANGLES);
    loopi(rb->tris_num) {
     t=rb->get_tri(i);
     glNormal3fv(t->n.get_data());
     glTexCoord2fv(t->t0.get_data()); glVertex3fv(t->v0.get_data());
     glTexCoord2fv(t->t1.get_data()); glVertex3fv(t->v1.get_data());
     glTexCoord2fv(t->t2.get_data()); glVertex3fv(t->v2.get_data());
    }
   glEnd();

   glPopMatrix();
  }
};

// CPhWall - trieda pre pracu s murom a jeho fyzikou ***********************
class CPhWall
{
 private:
  float t_scale; // zrychlenie/spomalenie plynutia casu
  float t_step;  // trvanie 1 vypoctu simulacie
  float t_next;  // cas, ktory uplynul od posledneho zaznamenaneho casoveho okamihu
  float t_last;  // casovy okamih po vykonani x vypoctov simulacie
  // pocet opakovani vypoctov simulacie
  int iter_num;

  // pocet tehal, z ktorych je zlozeny mur
  unsigned int bricks_num;
  // tehly, z ktorych je zlozeny mur - vytvori sa MAX_BRICKS RB
  CPhBrick bricks[MAX_BRICKS];

  // kolizne roviny
  CCollisionPlane planes[2];

  // detekcia a riesenie kolizii
  CCollisionDetection col_detection;

  // pomocne premenne pre zistenie zasahu RB strelbou
  triangle *t;
  vec3 f_vec,ip,ip_min,ip_min_bs;
  vec3 a,b;
  float d,d_min;
  int hit_RB,hit_t;

  // pomocna pamat pre obrazok diery po gulke
  unsigned char *data;

  // pomocne premenne
  float xs,ys,zs;
  float u,v;
  unsigned int ui,vi;
 public:
  // konstruktor
  CPhWall();
  // destruktor
  ~CPhWall();

  // vykreslenie muru
  // EP - poloha oci Avatara
  // TP - dopredu smerujuci vektor
  // F - Avatar striela/nestriela, CF - zbran je/nie je v pokoji
  // DT - prirastok casu = delta t
  void draw(vec3 EP,vec3 TP,unsigned char F,bool CF,float DT);
};

#endif
